#########################################
## THIS FILE IS PART OF BRAINGENIX     ##
## COMPUTER NEURON SIMULATUION LIBRARY ##
#########################################

import datetime

class Error_Logger(): # runs error logging


	def __init__(self, fname = 'log/MAIN.LOG', msg_per_write = 200): # logs the errors to the error_logger file

	
		## INITALIZE THE VARIABLES ##

		self.messages_per_write = msg_per_write # set the messages per write

		self.filename = fname # set the filename

		self.log = '' # initalize the log string

		self.writes = 0 # set the number of writes counter



	def print_log(self, message, condition = 0): # set the message and condition
		
		## HANDLE INFO CONDITION ##
		
		if condition == 0: # if the condition is info

			msg = '[{}] [INFO] {}'.format(str(datetime.datetime.now()), str(message)) # render the message

		if condition == 1: # if the condition is warn

			msg = '[{}] [WARN] {}'.format(str(datetime.datetime.now()), str(message)) # render the message

		if condition == 2: # if the condition is an error

			msg = '[{}] [ERROR] {}'.format(str(datetime.datetime.now()), str(message)) # render the message

		if condition == 3: # if the condition is fault

			msg = '[{}] [FAULT] {}'.format(str(datetime.datetime.now()), str(message)) # render the message

		if condition == 4: # if the condition is CRIT_FAULT

			msg = '[{}] [CRIT_FAULT]  **{}**'.format(str(datetime.datetime.now()), str(message)) # render the message


		self.log += msg + '\n' # append the log to the message

		print(msg) # print the message

		self.writes += 1 # incriment the log writes counter up by 1


		if (self.writes % self.messages_per_write == 0) or (condition != 0): # if it needs to be written to the log

			with open(self.filename, 'w') as f: # open the file with write permissions

				f.write(self.log) # write the log
			
