import setuptools
import os


with open("README.md", "r") as fh:
    long_description = fh.read()




pkgs = ['BrainGenix', 'BrainGenix/core',
        'BrainGenix/graphutils', 'BrainGenix/multiprocessing']


setuptools.setup(
    name="BrainGenix",
    version="0.0.2",
    author="Thomas Liao",
    author_email="thomasl20@icloud.com",
    description="A Biologically Accurate Simulator of Human Neurons.",
    long_description=long_description,
    long_description_content_type="text/markdown",
    url="https://github.com/datacrystals/BrainGenix",
    packages=pkgs,
    include_package_data=True,
    classifiers=[
        "Programming Language :: Python :: 3",
        "License :: OSI Approved :: GNU General Public License v3 (GPLv3)",
        "Operating System :: OS Independent",
    ],
    python_requires='>=3.5',
)
